import xlrd
import csv
import os

import xlsutil

## worksheet_name = "Archaeological reports"


def excel_to_sanitized_csv(excel_filename):
    workbook = xlrd.open_workbook(excel_filename)
    # worksheet = workbook.sheet_by_name(worksheet_name)
    worksheet = workbook.sheet_by_index(0)

    excel_filename_split = os.path.split(excel_filename)
    excel_dirname = excel_filename_split[0]
    excel_file = excel_filename_split[1]
    excel_file_splitext = os.path.splitext(excel_file)
    excel_file_root = excel_file_splitext[0];

    sanitized_csv_filename  = os.path.join(excel_dirname,excel_file_root+".csv")

    # print "Worksheet: " + worksheet_name
    sanitized_csv_ofile = open(sanitized_csv_filename, 'wb')

    sanitized_csv_wr  = csv.writer(sanitized_csv_ofile, quoting=csv.QUOTE_ALL)

    # 1. For header line, Build up hashmap of header-names to column number
    # 2. Write out CSV file for only the header-names in 'sanitized_headers'

    num_rows = worksheet.nrows

#    row_i = 0
#    num_header_cols = worksheet.row_len(row_i)

    # 1. get header-map
    header_names_mapping = xlsutil.getHeaderMappingToColNum(worksheet)

#    found_header = False
#    for col_j in range(num_header_cols):
#        header_cell_value = worksheet.cell_value(row_i,col_j)
#        if header_cell_value == "Report Identifier":
#            found_header = True
#
#        header_names_mapping[header_cell_value] = col_j
#
#    if not(found_header):
    if header_names_mapping is None:
        print "Failed to find \"Report Identifier\" header in spreadsheet (Row 0 or Sheet 0)"
        exit(1)

    # Move on to the start of the data values
    row_i = 1

    # 2. Write out CSV file ...
    while row_i<num_rows:
        # Work through sanitized header names building up row of utf8 values
        sanitized_utf8_row = []

        for header_name in xlsutil.sanitized_headers:

            if header_name in header_names_mapping:
                header_col_j = header_names_mapping[header_name]

                cell_value = worksheet.cell_value(row_i,header_col_j)



                cell_value_utf8 = unicode(cell_value).encode("utf-8")

                sanitized_utf8_row.append(cell_value_utf8)
            else:
                print("Warning: Failed to column mapping in spreadsheet for header name \""+header_name+"\" => skipping")
                
        sanitized_csv_wr.writerow(sanitized_utf8_row)

        row_i = row_i + 1

    sanitized_csv_ofile.close()

if __name__ == "__main__":
    excel_to_sanitized_csv(os.sys.argv[1])

